/*                                                                                                            
 * Copyright (c) Members of the EGEE Collaboration. 2004.
 * See http://eu-egee.org/partners/ for details on the copyright holders.
 * For license conditions see the license file or
 * http://eu-egee.org/license.html
 */

/*
 * Copyright (c) 2001 EU DataGrid.
 * For license conditions see http://www.eu-datagrid.org/license.html
 *
 * Copyright (c) 2001, 2002, 2003 by
 *     Oscar Koeroo <okoeroo@nikhef.nl>
 *     NIKHEF Amsterdam, the Netherlands
 */  

/*****************************************************************************
                            Include header files
******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
 
/* 
 * #include <sql.h>
 * #include <sqlext.h>
 */

#include <openssl/x509.h>
#include <openssl/asn1.h>

/******************************************************************************
                                Definitions
******************************************************************************/

#define MAXCOLS         32
#define EMPTYSET        5

#define LOCK_READ       1
#define LOCK_WRITE      2


typedef struct TField_s
{
    char * fieldname;
    char * value;
    int    type;
} TField;
 
typedef TField *  TRow;
 
typedef struct TColumn_s
{
    char * columnname;
    int    type;
} TColumn;
 
typedef struct TResultSet_s
{
    TRow *    data;
    TColumn * columns;
    int       colCnt;
    int       rowCnt;
} TResultSet;


typedef struct cert_s
{
    X509      * X509cert;
    char      * certStr;
    char      * PEM;

    char      * subject_name;
    char      * issuer_name;
    char      * strNotBefore;
    char      * strNotAfter;

} TSimpleCert;


typedef struct params_s
{
    char      * id;
    char      * value;
    int         type;
} TParamType;

 
/******************************************************************************
                          Module specific prototypes
******************************************************************************/

int ODBC_Test (char *, char *, char *);

int ODBC_Connect (char *, char *, char *);
//int  ODBC_Connect (char *);
//int  ODBC_Errors (char *);
char * ODBC_Errors (char *);
int  ODBC_Disconnect (void);
void ODBC_MesgHandler (char *);

int  SQL_SetLock (char * table, int kindOfLock);
int  SQL_UnLock ();
int  SQL_Commit ();
int  SQL_Rollback ();

int  SQL_Query (char *);
int  SQL_SetParameter (char *);
int  SQL_GetQueryResult(TResultSet **);
int  SQL_GetValue (TResultSet *, char *, char **);

int  SQL_printfResultSet (TResultSet *);
int  SQL_fprintfResultSet (FILE *, TResultSet *);

void TResultSet_free (TResultSet *);
void TSimpleCert_free (TSimpleCert *, int);
/******************************************************************************
                       Define module specific variables
******************************************************************************/
 
/*
 * SQLHENV henv;
 * SQLHDBC hdbc;
 * SQLHSTMT hstmt;
 * int connected;
 * TParamType * globalParameters = NULL;
 *
 */

/*****************************************************************************/
